import { Injectable } from '@angular/core';
import {
  CanActivate,
  CanActivateChild,
  ActivatedRouteSnapshot,
  RouterStateSnapshot
} from '@angular/router';
import { Store } from '@ngrx/store';

import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/take';
import 'rxjs/add/operator/map';

import * as AuthStore from 'packages/member/store/auth';
import { AuthSelector } from 'packages/member/store';

@Injectable()
export class AuthGuard implements CanActivate, CanActivateChild {
  constructor(
    private store: Store<AuthStore.State>
  ) { }

  canActivate(next: ActivatedRouteSnapshot, state: RouterStateSnapshot): Observable<boolean> {
    return this.store
      .select(AuthSelector.select('signined'))
      .map(signined => {
        if (!signined) {
          this.store.dispatch(new AuthStore.SigninRedirect());
          return false;
        }

        return true;
      })
      .take(1);
  }

  canActivateChild(next: ActivatedRouteSnapshot, state: RouterStateSnapshot): Observable<boolean> {
    return this.store
      .select(AuthSelector.select('signined'))
      .map(signined => {
        if (!signined) {
          this.store.dispatch(new AuthStore.SigninRedirect());
          return false;
        }

        return true;
      })
      .take(1);
  }
}
