export class RPCRegistry {
  private services: Map<string, Object>;

  public constructor() {
    this.services = new Map();
  }

  public registerService(receiver: Object, name?: string): void {
    if (undefined === name) {
      name = receiver.constructor.name;
    }
    this.services.set(name, receiver);
  }

  public getService(name: string): any | undefined {
    return this.services.get(name);
  }

  public hasMethod(method: string): boolean {
    const names = method.split('.');
    if (undefined === names || 2 !== names.length) {
      throw new Error();
    }
    const serviceName = names[0];
    const methodName = names[1];

    const service = this.services.get(serviceName);
    if (undefined === service || !service.hasOwnProperty(methodName)) {
      return false;
    }

    return true;
  }


}
