import { HttpErrorResponse } from '@angular/common/http';

export class ErrorResponse {

  private constructor(
    private _code: number,
    private _exception: string,
    private _message: string,
    ) {
  }

  public get code(): number {
    return this._code;
  }
  public get exception(): string {
    return this._exception;
  }
  public get message(): string {
    return this._message;
  }

  public static restError(errorResponse: HttpErrorResponse): ErrorResponse {
    const aryMsg = errorResponse.error.message.split('|');
    const resError: ErrorResponse = new ErrorResponse(
      errorResponse.error.code,
      aryMsg[0],
      aryMsg[1] === 'null' ? '' : aryMsg[1],
    );
    return resError;
  }
}

