import { ErrorResponse } from 'packages/commons/service/error-response';

import { DiscoveryStartInfo } from '../../model';

export interface State {
  isStart: boolean;
  error: ErrorResponse | null;
  isPending: boolean;
  discoveryStartInfo: DiscoveryStartInfo | null;
}

export const initialState: State = {
    isStart: false,
  error: null,
  isPending: false,
  discoveryStartInfo: null,
};

export const isStart = (state: State) => state.isStart;
export const getDiscoveryStartInfo = (state: State) => state.discoveryStartInfo;
export const getError = (state: State) => state.error;
export const isPending = (state: State) => state.isPending;
