import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Observable';

import 'rxjs/add/operator/map';

import { RESTService } from 'packages/commons/service/rest.service';

import { Infra } from '../model';
import { Page } from '../../../app/commons/model';
import { Domain } from '../../domain/model';
import { Probe } from '../../probe/model';

@Injectable()
export class InfraService {

  public constructor(
    private restService: RESTService,
  ) {

  }

  public readByDomain(domain: Domain): Observable<Page> {
    return this.restService.post<Page>('/account/signin', domain);
  }

  public readByProbe(probe: Probe): Observable<Page> {
    return this.restService.post<Page>('/account/signup', probe);
  }
}
