import {
  createSelector,
  MemoizedSelector,
} from '@ngrx/store';

import { ErrorResponse } from 'packages/commons/service/error-response';
import { Infra } from '../../model';
import { Page } from '../../../../app/commons/model';

export interface State {
  isSignin: boolean;
  error: ErrorResponse | null;
  isPending: boolean;
  infraList: Page | null;
}

export const initialState: State = {
  isSignin: false,
  error: null,
  isPending: false,
  infraList: null,
};

export class StateSelector {
  public constructor(private _selector: MemoizedSelector<any, any>) {
  }

  public getInfraList = createSelector(this._selector, (state: State) => state.infraList);
  public getError = createSelector(this._selector, (state: State) => state.error);
  public isPending = createSelector(this._selector, (state: State) => state.isPending);
}
