import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Observable';

import 'rxjs/add/operator/map';

import { RESTService } from 'packages/commons/service/rest.service';
import { DomainMember } from 'packages/domain/model';

import { Member } from '../model';

@Injectable()
export class MemberService {

  public constructor(
    private restService: RESTService,
  ) {

  }

  public signin(email: string, password: string): Observable<DomainMember> {
    const body = {
      signinId: email,
      signinPw: password,
    };

    return this.restService.post<DomainMember>('/account/signin', body);
  }

  public signup(member: Member): Observable<Member> {
    return this.restService.post<Member>('/account/signup', member);
  }
}
