import { Action } from '@ngrx/store';

import { ErrorResponse } from 'packages/commons/service/error-response';

import { Member } from '../../model';

export enum ActionType {
  Signup = '[member.signup] Signup',
  SignupSuccess = '[member.signup] SignupSuccess',
  SignupFailure = '[member.signup] SignupFailure',
}

export class Signup implements Action {
  readonly type = ActionType.Signup;

  constructor(public payload: Member) {}
}

export class SignupSuccess implements Action {
  readonly type = ActionType.SignupSuccess;

  constructor(public payload: Member) {}
}

export class SignupFailure implements Action {
  readonly type = ActionType.SignupFailure;

  constructor(public payload: ErrorResponse) {}
}

export type Actions =
  | Signup
  | SignupSuccess
  | SignupFailure
;
