import { Component, OnInit, AfterViewInit, ViewChild } from '@angular/core';
import { MatTableDataSource, MatSort } from '@angular/material';
import { AfterContentInit } from '@angular/core/src/metadata/lifecycle_hooks';
import { Router } from '@angular/router';
import { Store } from '@ngrx/store';
import * as ListStore from '../../store/noauth-probe';
import { Domain } from '../../../domain/model';
import { NoAuthProbe } from '../../model';

@Component({
  selector: 'of-noauth-list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.scss']
})
export class ListComponent implements OnInit, AfterContentInit {

  selected: NoAuthProbe = null;

  displayedColumns = ['select', 'id', 'description', 'createDate'];
  dataSource: MatTableDataSource<NoAuthProbe>;
  @ViewChild(MatSort) sort: MatSort;

  constructor(
    private router: Router,
    private store: Store<ListStore.State>
  ) { }

  ngAfterContentInit() {
    // const domain: Domain = {
    //   id: 1,
    // };
    // this.store.dispatch(new ListStore.ReadAllByDomain(domain));

    // temporary data
    const data: NoAuthProbe[] = new Array();
    for (let i = 0; i < 5; i++) {
      const p: NoAuthProbe = {
        id: i,
        description: String('desc' + i),
        createDate: new Date()
      };
      data.push(p);
    }

    this.dataSource = new MatTableDataSource(data);
    this.dataSource.sort = this.sort;
  }

  ngOnInit() {
  }

  handleSelect(selected: NoAuthProbe) {
    this.selected = selected;
  }

  handleAccept() {
    console.log(this.selected.id + ' accept');
  }

  handleDeny() {
    console.log(this.selected.id + ' deny');
  }
}
