import { ErrorResponse } from 'packages/commons/service/error-response';

import { NoAuthProbe } from '../../model';

export interface State {
  error: ErrorResponse | null;
  isPending: boolean;
  noAuthProbes: NoAuthProbe[] | null;
}

export const initialState: State = {
  error: null,
  isPending: false,
  noAuthProbes: null,
};

export const getNoAuthProbes = (state: State) => state.noAuthProbes;
export const getError = (state: State) => state.error;
export const isPending = (state: State) => state.isPending;
