import { Action } from '@ngrx/store';

import { ErrorResponse } from 'packages/commons/service/error-response';

import { Domain } from 'packages/domain/model';
import { Probe } from '../../model';


export enum ActionType {
  ReadAllByDomain = '[probe.list] ReadAllByDomain',
  ReadAllByDomainSuccess = '[probe.list] ReadAllByDomainSuccess',
  ReadAllByDomainFailure = '[probe.list] ReadAllByDomainFailure',
}

export class ReadAllByDomain implements Action {
  readonly type = ActionType.ReadAllByDomain;

  constructor(public payload: Domain) {}
}

export class ReadAllByDomainSuccess implements Action {
  readonly type = ActionType.ReadAllByDomainSuccess;

  constructor(public payload: Probe[]) {}
}

export class ReadAllByDomainFailure implements Action {
  readonly type = ActionType.ReadAllByDomainFailure;

  constructor(public payload: ErrorResponse) {}
}


export type Actions =
  | ReadAllByDomain
  | ReadAllByDomainSuccess
  | ReadAllByDomainFailure
;
