import { Component, ViewChild, OnInit, Input } from '@angular/core';
import { MatPaginator, MatTableDataSource } from '@angular/material';
import { AfterContentInit, AfterViewInit } from '@angular/core/src/metadata/lifecycle_hooks';

@Component({
  selector: 'of-target-detail',
  templateUrl: './detail.component.html',
  styleUrls: ['./detail.component.scss']
})
export class DetailComponent implements OnInit, AfterViewInit, AfterContentInit {

  displayedColumns = ['sensorType', 'itemCnt', 'status'];
  sensors: MatTableDataSource<any> = null;
  @ViewChild(MatPaginator) paginator: MatPaginator;

  basicInfo = [
    {
      key: 'IP',
      value: '192.168.1.105',
    },
    {
      key: 'Mac',
      value: 'aaaaaaaaaaaaa',
    },
    {
      key: 'OS',
      value: 'Ubuntu',
    },
    {
      key: 'Port',
      value: '80',
    },
  ];
  metaInfo = [
    {
      key: 'Meta1',
      value: 'value1',
    },
    {
      key: 'Meta2',
      value: 'value2',
    },
    {
      key: 'Meta3',
      value: 'value3',
    },
    {
      key: 'Meta4',
      value: 'value4',
    },
  ];

  constructor() { }

  ngOnInit() {
  }

  ngAfterViewInit() {
    this.sensors.paginator = this.paginator;
  }

  ngAfterContentInit() {
    const sensors = [
      {
        sensorType: 'WMI',
        itemCnt: '5',
        status: 'Up',
      },
      {
        sensorType: 'SSH',
        itemCnt: '5',
        status: 'Up',
      },
    ];
    this.sensors = new MatTableDataSource<any>(sensors);
  }

  handleSensorClick(row: any) {
    console.log(row);
  }

  handleCheckAlive() {
  }

  handleTraceroute() {
  }
}
